import { EventEmitter } from '@angular/core';
import { Panel } from './panel';
export declare class AccordionComponent {
    /**
     * 数据源
     *
     * @type {object}
     */
    panels: Panel[];
    /**
     * 激活的panel下标, 如果为-1视为全部折叠
     * @default 0
     */
    activeIndex: number;
    /**
     * 是否hover展开
     *
     */
    hoverable: boolean;
    /**
     * 折叠方式，互斥折叠 or 全部可折叠
     * @default false 互斥折叠
     *
     */
    collapsible: boolean;
    /**
     *  panel 活动状态发生改变时事件 emit
     *
     */
    change: EventEmitter<object>;
    constructor();
    /**
     * 变更活动状态的索引
     *
     * @param {number} activeIndex - 指定索引
     */
    changeActiveIndex(activeIndex: number): void;
    /**
     * 激活指定panel
     *
     * @param {number} activeIndex - 指定索引
     */
    onActivatePanel(activeIndex: number): void;
}
