/**
 * breadcurmb item type
 */
export declare type BreadcrumbItem = {
    /** breadcrumb text. */
    text: string;
    /** breadcrumb path, using with router. */
    path?: string;
    /**
     * breadcrumb href, using with href, when both path and href presents,
     * href has high priority.
     */
    href?: string;
    /**
     * breadcrumb path query params
     */
    queryParams?: any;
};
/**
 * Breadcrumb Component
 */
export declare class BreadcrumbComponent {
    /**
     * breadcrumb datasource, each item contains a `text`、`path`（optional）、`href`（optional）property
     * @default []
     */
    datasource: BreadcrumbItem[];
    /**
     * the common query params for every router link
     * @type {*}
     */
    queryParams: any;
    /**
     * set trackby function for `ngFor`
     *
     * @param {BreadcrumbItem} item - breadcrumb item
     * @docs-private
     */
    trackByText(item: BreadcrumbItem): string;
}
