import { EventEmitter, TemplateRef, AfterViewInit, OnInit, Renderer2, ElementRef } from '@angular/core';
/**
 * Card Component
 */
export declare class CardComponent implements OnInit, AfterViewInit {
    private _el;
    private _render;
    /**
     * the event emitted when the component is disposed(removed from the dom)
     */
    dispose: EventEmitter<CardComponent>;
    /**
     * card width, in pixels
     * @default 540
     */
    width: number;
    /**
     * @docs-private
     */
    widthChange: EventEmitter<number>;
    /**
     * whether the card can be disposed
     * @default false
     */
    disposable: boolean;
    /**
     * the card extra theme, i.e. when theme is 'dialog', an extra class `nb-card-dialog`
     * will be appended to the host className property
     * @default ''
     */
    theme: string;
    _title: TemplateRef<any>;
    _operation: TemplateRef<any>;
    _body: TemplateRef<any>;
    _foot: TemplateRef<any>;
    constructor(_el: ElementRef, _render: Renderer2);
    /**
     * @docs-private
     */
    registerWidthChange(): void;
    ngOnInit(): void;
    /**
     * @docs-private
     */
    onDispose(): void;
    ngAfterViewInit(): void;
}
