import { ElementRef, AfterViewInit, Renderer2, OnChanges, SimpleChanges } from '@angular/core';
/**
 * Code Highlighter Component
 */
export declare class CodeHighlighterComponent implements AfterViewInit, OnChanges {
    private el;
    private render;
    /**
     * code language, see http://prismjs.com/index.html#languages-list
     * @default typescript
     */
    language: string;
    /**
     * whether show line numbers, default to false
     */
    linenumbers: boolean;
    /**
     * code style theme, todo
     * @docs-private
     */
    theme: string;
    /**
     * code line range highlight, todo
     * @docs-private
     */
    linehighlight: number;
    /**
     * raw code to be highlighted
     * @default ''
     */
    rawCode: string;
    /** code element */
    _code: ElementRef;
    /** ng-content wrapper element */
    _content: ElementRef;
    constructor(el: ElementRef, render: Renderer2);
    ngAfterViewInit(): void;
    /**
     * @docs-private
     */
    highlight(): void;
    ngOnChanges(changes: SimpleChanges): void;
}
