import { EventEmitter, OnInit } from '@angular/core';
import { OverlayComponent } from '../overlay';
export declare class DialogComponent extends OverlayComponent implements OnInit {
    /**
     * 是否为模态对话框
     * @default false
     */
    modalable: boolean;
    /**
     * 是否有关闭功能
     * @default true
     */
    closable: boolean;
    /**
     * 点击对话框的确认按钮时事件 emit
     */
    confirmEvent: EventEmitter<Object>;
    /**
     * 覆盖overlay的OnInit方法，不响应document click事件
     */
    ngOnInit(): void;
    /**
     * Dialog确定按钮的点击响应
     */
    confirm(): void;
}
