import { ElementRef } from '@angular/core';
import { ConnectedPositionStrategy } from './connected-position.strategy';
import { GlobalPositionStrategy } from './global-position.strategy';
/** Builder for overlay position strategy. */
export declare class OverlayPositionBuilder {
    constructor();
    /**
     * Creates a global position strategy.
     */
    global(): GlobalPositionStrategy;
    /**
     * Creates a relative position strategy.
     * @param elementRef
     * @param originPos
     * @param overlayPos
     */
    attachTo(targetRef: ElementRef, overlayRef: ElementRef): ConnectedPositionStrategy;
}
