import { EventEmitter } from '@angular/core';
/**
 * Circular Progress Bar Component
 */
export declare class ProgressBarCircleComponent {
    /**
     * circle radius(in pixels)
     * @default 124
     */
    radius: number;
    /**
     * progress bar percentage, 0~100
     * @default 0
     */
    percent: number;
    /**
     * @docs-private
     */
    percentChange: EventEmitter<number>;
    /**
     * Whether the progress is in success
     * @default false
     */
    isSuccess: boolean;
    /**
     * success text when done
     * @default 完成
     */
    successText: string;
    /**
     * Whether the progress is in error
     * @default false
     */
    isError: boolean;
    /**
     * error text when in error
     * @default 错误
     */
    errorText: string;
    /**
     * Whether show progress text
     * @default false
     */
    showProgressText: boolean;
    /**
     * get progress text
     * @docs-private
     */
    readonly progressText: string;
    /**
     * current percentage path's d string
     * @docs-private
     */
    circlePath: string;
    constructor();
}
