import { EventEmitter } from '@angular/core';
/**
 * Progress Bar Component
 */
export declare class ProgressBarComponent {
    /**
     * Emit a event with the current progress value when the progressbar is closed
     */
    close: EventEmitter<number>;
    /** Emit a event when the progressbar is refreshed */
    refresh: EventEmitter<number>;
    /**
     * Current progress bar value
     * @default 0
     */
    value: number;
    /**
     * Compute percent
     * @docs-private
     */
    readonly percent: number;
    /**
     * Progress bar max value
     * @default 100
     */
    maxValue: number;
    /**
     * Whether the progress is successful
     * @default false
     */
    isSuccess: boolean;
    /**
     * Success text when progress bar is done
     * @default 完成
     */
    successText: string;
    /**
     * Whether the progress is error
     * @default false
     */
    isError: boolean;
    /**
     * Error text when progress bar is error
     * @default false
     */
    errorText: string;
    /**
     * Whether show progress text
     * @default false
     */
    showProgressText: boolean;
    /**
     * Whether show operation buttons
     * @default false
     */
    showOperation: boolean;
    /**
     * close progressbar
     * @docs-private
     */
    onClose(): void;
    /**
     * refresh progressbar
     * @docs-private
     */
    onRefresh(): void;
}
