import { EventEmitter, OnInit, Renderer2, ElementRef } from '@angular/core';
import { Observable } from 'rxjs';
import { SliderService } from './slider.service';
import { TooltipDirective } from '../index';
export declare class SliderHandComponent implements OnInit {
    private render;
    private service;
    /**
     * The range of dragging, width or height of the component
     */
    limitMove: number;
    /**
     * Orientation of the component
     */
    orientation: any;
    /**
     * The init position of hand
     */
    initPos: number;
    /**
     * Whether the slider is disabled or not
     */
    disabled: boolean;
    /**
     * Max value of the dragging
     */
    max: number;
    /**
     * Min value of the dragging
     */
    min: number;
    /**
     * Step of dragging
     */
    step: number;
    value: string;
    placement: string;
    /**
     * The event emitted when slider value changes, emit the init position and end position of hand
     */
    change: EventEmitter<object>;
    _hand: ElementRef;
    tooltip: TooltipDirective;
    constructor(render: Renderer2, service: SliderService);
    ngOnInit(): void;
    /**
     * Bind element event
     */
    bindEvent(): void;
    /**
     * mousemove事件流
     * @param initialState mousedown时的位置信息
     */
    moveUntilUp(initialState: any): Observable<object>;
    /**
     * 更新hand位置
     * @param pos mouseup时的位置信息
     */
    updateHand(pos: any): void;
    /**
     * update end position of hand
     * @param val position
     */
    updateStyle(val: number): void;
}
