import { EventEmitter, AfterViewInit, ElementRef, Renderer2, OnInit, QueryList, ChangeDetectorRef } from '@angular/core';
/**
 * Step component
 */
export declare class StepComponent implements AfterViewInit {
    private _el;
    private _render;
    /** current step value */
    value: number;
    valueChange: EventEmitter<number>;
    /** custom skin value */
    skin: string;
    /** step item list chilren */
    _children: QueryList<StepItemComponent>;
    constructor(_el: ElementRef, _render: Renderer2);
    ngAfterViewInit(): void;
    /**
     * update children status
     *
     * @param {number} step - current step
     * @docs-private
     */
    updateChildrenStatus(step: number): void;
}
/**
 * Step item component
 */
export declare class StepItemComponent implements AfterViewInit, OnInit {
    private _el;
    private _render;
    private _cd;
    /**
     * step item value
     */
    value: number;
    _success: boolean;
    /** Whether the step item is done success */
    success: any;
    /** Whether the step item is done error */
    error: boolean;
    /** Whether the step item is active */
    active: boolean;
    /** The extra skin class */
    skin: string;
    /** The optional parent step component */
    _parentBox: StepComponent;
    constructor(parentBox: StepComponent, _el: ElementRef, _render: Renderer2, _cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
