import { EventEmitter, OnInit, AfterViewChecked, QueryList, AfterViewInit, ChangeDetectorRef } from '@angular/core';
import { TabComponent } from './tab';
import { InkBarComponent } from './ink-bar';
import { TabHeaderComponent } from './tab-header';
/** default tab size types */
export declare type TABS_SIZE = 'default' | 'large' | string;
export declare class TabsComponent implements OnInit, AfterViewInit, AfterViewChecked {
    private cdRef;
    /**
     * Tabs尺寸, 'default' | 'large'
     * @default default
     */
    size: TABS_SIZE;
    /**
     * Tabs是否有下划线, true | false
     * @default false
     */
    underline: boolean;
    /**
     * 各Tab间是否有分割线, true | false
     * @default false
     */
    splitline: boolean;
    /**
     *  panel 活动状态发生改变时事件 emit
     *
     */
    change: EventEmitter<object>;
    tabs: QueryList<TabComponent>;
    inkBar: InkBarComponent;
    tabHeader: QueryList<TabHeaderComponent>;
    activeIndex: number;
    initializeActiveIndexChange: boolean;
    constructor(cdRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    /**
     * 设置当前Tab为选中状态
     *
     * @param {number} index - 当前Tab的索引
     */
    setActive(index: number): void;
    /**
     * 设置选中线的位置
     *
     */
    alignInkBar(): void;
}
