import { ChangeDetectorRef, Renderer2, OnInit, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export declare class TextLineComponent implements OnInit, ControlValueAccessor {
    private _cd;
    private _render;
    /**
     * text-line value
     * @default ''
     */
    value: string;
    /**
     * text-line placeholder
     * @default ''
     */
    placeholder: string;
    /**
     * Whether the text-line is disabled
     * @default false
     */
    disabled: boolean;
    /**
     * content dom
     * @docs-private
     */
    lines: any[];
    txtContent: ElementRef;
    constructor(_cd: ChangeDetectorRef, _render: Renderer2);
    ngOnInit(): void;
    /**
     * in text-line content region input string
     * @docs-private
     */
    onInput(event: any, txtContent: any, txtLines: any): void;
    onBlur(): void;
    /**
     * listen text-line content region scroll event
     * @docs-private
     */
    scrollHandler(event: any, txtLines: any): void;
    /**
     * The method to be called in order to update ngModel.
     * Now `ngModel` binding is not supported in multiple selection mode.
     */
    private _onModelChange;
    /**
     * Registers a callback that will be triggered when the value has changed.
     * Implemented as part of ControlValueAccessor.
     * @param fn On change callback function.
     */
    registerOnChange(fn: Function): void;
    /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
    private _onTouch;
    /**
     * Registers a callback that will be triggered when the control has been touched.
     * Implemented as part of ControlValueAccessor.
     * @param fn On touch callback function.
     */
    registerOnTouched(fn: Function): void;
    /** set text-line model value */
    writeValue(value: any): void;
    /**
     * Toggles the disabled state of the component. Implemented as part of ControlValueAccessor.
     * @param {boolean} isDisabled - Whether the component should be disabled.
     */
    setDisabledState(isDisabled: boolean): void;
    /**
     * update form model value and mark for check
     * @docs-private
     */
    _markForCheck(): void;
}
