import { ElementRef, SimpleChanges, AfterViewInit, OnChanges, ChangeDetectorRef } from '@angular/core';
import { TextareaConfig } from './textarea.config';
/** default textarea theme types */
export declare type TEXTAREA_THEME = 'default' | 'error' | string;
export declare class TextareaDirective implements OnChanges, AfterViewInit {
    private el;
    private _config;
    private cd;
    /**
     * textarea theme, there two default themes: 'default' | 'error'
     * @default default
     */
    theme: TEXTAREA_THEME;
    /**
     * Whether the textarea is disabled
     * @default false
     */
    disabled: boolean;
    constructor(el: ElementRef, _config: TextareaConfig, cd: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    /**
     * set host element classes
     * @docs-private
     */
    setClass(): void;
    /**
     * get host element classes, depends on the theme.
     * @return {string} class names
     * @docs-private
     */
    getClassName(): string;
}
