import { ElementRef, OnDestroy, OnInit, EventEmitter } from '@angular/core';
import { OverlayComponent } from '../overlay';
export declare class TiplayerComponent extends OverlayComponent implements OnInit, OnDestroy {
    /**
     * 提示框宽度
     */
    nbWidth: number;
    /**
     * 提示框高度
     */
    nbHeight: number;
    /**
     * 提示框
     */
    nbTooltipClass: string;
    /**
     * 提示框主题色
     * 可选值为 'default' | white' | 'pink' | 'yellow'
     */
    nbTooltipTheme: string;
    /**
     * 提示框的触发事件类型
     * 可选值为 'click' | 'hover' | 'focus'
     */
    trigger: string;
    /**
     * 是否有箭头
     * @default false
     */
    hasArrow: boolean;
    /**
     * 浮层模式还是嵌入模式
     */
    embedded: boolean;
    /**
     * 变更可见性时的延迟时间
     * @default 200
     */
    delay: number;
    /**
     * 需要重新定位的事件
     */
    needReposition: EventEmitter<Object>;
    /**
     * 箭头元素
     */
    arrow: ElementRef;
    /**
     * 提示内容子视图，用于变更内容用。e.g slider的提示
     */
    content: ElementRef;
    ngOnInit(): void;
    /**
     * 变更提示框的内容，e.g slider的提示
     * @param { string } content
     */
    changeContent(content: any): void;
    /**
     * 处理提示框中的mouseEnter事件
     */
    onMouseEnter(): void;
    /**
     * 处理提示框中的mouseLeave事件
     */
    onMouseLeave(): void;
    ngOnDestroy(): void;
}
