import { EventEmitter, ChangeDetectorRef, OnDestroy } from '@angular/core';
import { TransferService } from './transfer.service';
export declare class TransferComponent implements OnDestroy {
    private _cd;
    private service;
    /** search event */
    searchValue: EventEmitter<object>;
    /** tree node expand event */
    onExpandNode: EventEmitter<object>;
    /** tree node all trans event */
    onTransAll: EventEmitter<object>;
    /** tree add extend data event */
    onExtendData: EventEmitter<object>;
    /**
     * Whether the transfer is disabled
     * @default false
     */
    disabled: boolean;
    /**
     * Whether the transfer is can all-trans
     * @default false
     */
    allSelectLink: boolean;
    /**
     * Whether the transfer is can all-delete
     * @default false
     */
    allDeleteLink: boolean;
    /**
     * Whether the transfer candidate is have search
     * @default false
     */
    candidateSearch: boolean;
    /**
     * Whether the transfer selected is have search
     * @default false
     */
    selectedSearch: boolean;
    /**
     * candidate list title
     */
    candidateTitle: string;
    /**
     * selected list title
     */
    selectedTitle: string;
    /**
     * add extend data link config
     */
    addLink: any;
    /**
     * all options count
     * @docs-private
     */
    candidateCount: number;
    /**
     * all selected options count
     * @docs-private
     */
    selectedCount: number;
    private subscription;
    constructor(_cd: ChangeDetectorRef, service: TransferService);
    ngOnDestroy(): void;
    /**
     * clear search results
     * @docs-private
     */
    clearSearch(event: string, mode: string): void;
    /**
     * fitler candidate or selected list by key word
     * @docs-private
     */
    searchByKeyWord(event: string, mode: string): void;
    /**
     * tree node expand event
     * @docs-private
     */
    expandNode(event: any): void;
    /**
     * trans all options to Selected or not
     * @docs-private
     */
    transAll(mode: string, chkVal: boolean): void;
    /**
     * extend data
     * @docs-private
     */
    extendData(): void;
}
